{
 Das altererste  Beispiel zur OOP (objektorientierte Programmierung)
 ==================================================================
 An einfachen Beispiel wird erklrt, wie in Delphi Klassen
 gebildet werden.
 TPerson hat die Eigenschaften "Name", "Geburtstag", "Geburtsort"
   und die Methode "anzeigen"
 Tschueler erbt alles von TPerson und hat zustzlich die Eigenschaften
   "Klasse" und "Sprachen". TSchler hat wie TPerson die Methode
   "anzeigen". Zum Ererbten wird jedoch noch etwas hinzugefgt.
 Die Klasse TPerson wird noch abgewandelt.
   *) mit einem Constructor
   *) mit einer Kapselung
 Die Kapselung wird auch noch an einem Kreis gezeigt. Seine
 Eigenschaft "Umfang" und "Flaeche" knnen nur gelesen werden.

 Stichworte: OOP
             Objektorientiertes Programmieren
             Felder
             Eigenschaften
             Methoden
             Constructor
             Vererbung
             berschreiben
             Kapselung (read write)


}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

//Eine Klasse TPerson mit den Feldern name, geburtsort und geburtsdatum und der
//Methode anzeigen.
type TPerson = class
       Fname : string;
       Fgeburtstag : string;
       Fgeburtsort : string;
       procedure anzeigen;
     end;
//Wir bilden eine Unterklasse Tschueler, die alle Attribute und Methoden von
//TPerson erbt und zustzlich die Felder Klasse und Sprachen enthlt.
     Tschueler = class(TPerson)
       Fklasse : string;
       Fsprachen : string;
       procedure anzeigen;
     end;
//Als nchstes erhlt die Klasse Tperson einen eigenen Konstruktor,
// mit dem die Felder initialisiert werden.
     TPersonMitConstructor = class
       Fname : string;
       Fgeburtstag : string;
       Fgeburtsort : string;
       constructor Create(Fname,Fgeburtstag,Fgeburtsort:string);
       procedure anzeigen;
     end;
{Ein wichtiges Prinzip beim Objektorientierten Programmieren ist das der
 Kapselung. Nach Mglichkeit soll nicht direkt auf die Felder des Objekts
 zugegriffen werden, sondern nur ber eigene Zugriffsmethoden.
 Wir verpassen daher unserer Klasse Tperson die Eigenschaften (properties)
 name, geburtstag und geburtstort.}
     TPersonMitKapselung = class(TObject)
       private
            Fname : string;
            Fgeburtstag : string;
            Fgeburtsort : string;
            function  Getname:string;
            procedure Setname(name:string);
            function  Getgebtag:string;
            procedure Setgebtag(geburtstag:string);
            function  Getgebort:string;
            procedure Setgebort(geburtsort:string);
       public
            constructor Create(Fname,Fgeburtstag,Fgeburtsort:string);
            property name:string read Getname  write Setname;
            property geburtstag:string read Getgebtag write Setgebtag;
            property geburtsort:string read Getgebort write Setgebort;
       end;
// Zur Kapselung noch ein weiteres Beispiel;
    TKreis=Class(Tobject)
       private
            Fradius : real; //Feld
            function  GetRadius:real;
            procedure SetRadius(radius:real);
            function  GetUmfang:real;
            function  GetFlaeche:real;
       public
            constructor Create(Radius:Real);
            property Radius:real  read GetRadius  write SetRadius; //Eigenschaft
            property Umfang:real  read GetUmfang;
            property Flaeche:Real read GetFlaeche;
            procedure zeichne(x,y:integer);
    end;
var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TPerson.anzeigen;
begin
     form1.memo1.lines.add('Name       : '+Fname+#13#10+
                           'Geburtstag : '+Fgeburtstag+#13#10+
                           'Geburtsort : '+Fgeburtsort);
end;

procedure Tschueler.anzeigen;
begin
     inherited anzeigen;
     Form1.memo1.lines.add('Klasse       :'+Fklasse+#13#10+
                             'Sprachen   :'+Fsprachen);
end;

constructor TPersonMitConstructor.Create(Fname,Fgeburtstag,Fgeburtsort:string);
begin
     inherited Create;
     self.Fname := Fname;
     self.Fgeburtstag := Fgeburtstag;
     self.Fgeburtsort := Fgeburtsort;
end;

procedure TPersonMitConstructor.anzeigen;
begin
 form1.memo1.lines.add('Name       : '+Fname+#13#10+
                           'Geburtstag : '+Fgeburtstag+#13#10+
                           'Geburtsort : '+Fgeburtsort);
end;
//----------------- Mit Kapselung -------------------------------
function TPersonMitKapselung.Getname;
begin
     result := Fname;
end;

function TPersonMitKapselung.Getgebtag;
begin
     result := Fgeburtstag;
end;

function TPersonMitKapselung.Getgebort;
begin
     result := Fgeburtsort;
end;

procedure TPersonMitKapselung.Setname;
begin
     Fname := name;
end;

procedure TPersonMitKapselung.Setgebtag;
begin
     Fgeburtstag := geburtstag;
end;

procedure TPersonMitKapselung.Setgebort;
begin
     Fgeburtsort := geburtsort;
end;

constructor TPersonMitKapselung.Create;
begin
     inherited Create;
     self.Fname := Fname;
     self.Fgeburtstag := Fgeburtstag;
     self.Fgeburtsort := Fgeburtsort;
end;
//-------- Zweites Beispiel fr Kapselung: Kreis ---------------
constructor TKreis.Create(radius:real);
begin
   inherited Create;
   fRadius:=Radius;
end;

function  TKreis.GetRadius:real;
begin result:=FRadius end;

procedure TKreis.SetRadius(radius:real);
begin FRadius:=Radius end;

function  TKreis.GetUmfang:real;
begin result:=2*PI*FRadius end;

function  TKreis.GetFlaeche:real;
begin result:=Pi*FRadius*Fradius end;

procedure TKreis.zeichne(x,y:integer);
begin
  form1.Canvas.Brush.Color := clRed;;
  form1.Canvas.Ellipse(x-round(Fradius*10),y-round(Fradius*10),
                       x+round(Fradius*10),y+round(Fradius*10));
end;



procedure TForm1.Button1Click(Sender: TObject);
  var  person1, person2 : TPerson;
begin
     person1 := TPerson.create;
     person2 := TPerson.create;
     person1.Fname := 'Karl Mayer';
     person1.Fgeburtstag := '13.7.1981';
     person1.Fgeburtsort := 'Rottenburg';

     person2.Fname := 'Viola Krautt';
     person2.Fgeburtstag := '1.7.1982';
     person2.Fgeburtsort := 'Hirrlingen';

     form1.Memo1.Clear;
     form1.memo1.lines.add('1. Person (3 Eigenschaften)');
     person1.anzeigen;
     form1.memo1.lines.add('2. Person');
     person2.anzeigen;

     person1.Free; //Das Leben ist kurz und zeitraubend und endet
     person2.Free; //meistens mit dem Tod.

end;

procedure TForm1.Button2Click(Sender: TObject);
   var schueler1:Tschueler;
begin
     schueler1 := Tschueler.create;
     schueler1.Fname := 'Karin Mller';
     schueler1.Fgeburtstag := '17.10.1981';
     schueler1.Fgeburtsort := 'Tbingen';
     schueler1.Fklasse := '12 Tutot A-K';
     schueler1.Fsprachen := 'Franzsisch Englisch';
     form1.Memo1.Clear;
     form1.memo1.lines.add('Schler (5 Eigenschaften)');
     schueler1.anzeigen;
     schueler1.free; //Ein kurzes Leben
end;

procedure TForm1.Button3Click(Sender: TObject);
   var  person1, person2 : TPersonMitConstructor;
begin
  person1:=TPersonMitConstructor.Create('Adrian Mck','13.10.1992','Tbingen');
  person2:=TPersonMitConstructor.Create('Maren Oswald','05.07.1992','Bblingen');
  form1.Memo1.Clear;
  form1.memo1.lines.add('Zwei Personen'#13#10+'=================');
  person1.anzeigen;
  person2.anzeigen;
  person1.Free;
  person2.Free;
end;

procedure TForm1.Button4Click(Sender: TObject);
    var  person1 : TPersonMitKapselung;

begin
     person1 := TPersonMitKapselung.create('Mira Zllner',
                        '05.07.1992','Reutlingen');
     //Person1 hat nun die Eigenschaften name, geburtstag, geburtsort
     form1.Memo1.Clear;
     form1.memo1.lines.add('Person mit Kapselung'+#13#10+
                           'Name       : '+person1.name+#13#10+
                           'Geburtstag : '+person1.geburtstag+#13#10+
                           'Geburtsort : '+person1.geburtsort);
     person1.free;
end;

procedure TForm1.Button5Click(Sender: TObject);
  var kreis1:TKreis;
begin
  kreis1:=TKreis.Create(5);
  form1.Memo1.Clear;
  form1.memo1.lines.add('Kreis'#13#10'======'#13#10+
                        'Radius:'+floatToStr(kreis1.radius)+#13#10+
                        'Umfang:'+floatToStr(kreis1.umfang)+#13#10+
                        'Flche:'+floatToStr(kreis1.Flaeche));
  kreis1.zeichne(button5.left,button5.top);
  kreis1.Free;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  close;
end;

end.
